#ifndef __VEC_FUNC_FCNS_H
#define __VEC_FUNC_FCNS_H

#include <dolfin.h>
#include "forms/Scalar_L2Error.h"
#include "forms/Scalar_Integrate.h"
#include "forms/Scalar_Integrate_prod.h"
#include "forms/LSM_restrict.h"

namespace dolfin
{

  class Vec_Func_fcns 
  {
  public:

    Vec_Func_fcns(void);
    real L2_Error_Exact(Mesh&, Function&, Function&);
    real L2_Error_DF_DF(Mesh&, Function&, Function&);
    real integrate_fcn(Mesh&, Function&);
    real integrateLevelSet(Mesh&, Function&);
    real integrateLevelSet2(Mesh&, Function&);
    real computeRelError(Vector&, Vector&);
    Vector& restrictUFtoDF(Mesh&, Function&);
    real maxVal(Vector&);
    real maxMag(Vector&);

  private:

    LU lu_solver;

    Vector res_vec;
  };
}
#endif
